﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=10.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True		
#End Region

Sub Process_Globals
	Private nid As Int = 1
	Private lock As PhoneWakeState
	Public manager As BleManager2
	Public currentStateText As String 
	Public rp As RuntimePermissions	
End Sub


Sub Service_Create
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER
	manager.Initialize("manager")
	lock.PartialLock
End Sub


Sub Service_Start (StartingIntent As Intent)		
	Service.StartForeground(nid, CreateNotification("Scanning...","BLE Device"))
	StartServiceAt(Me, DateTime.Now + 30 * DateTime.TicksPerMinute, True)
	StartScan	
End Sub


Sub CreateNotification (Header As String, Body As String) As Notification
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_LOW)
	notification.Icon = "icon"
	notification.SetInfo(Header, Body, Main)
	Return notification
End Sub


Sub Service_Destroy
	lock.ReleasePartialLock
End Sub


Sub Manager_StateChanged (State As Int)
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "OFF"
		Case manager.STATE_POWERED_ON
			currentStateText = "ON"
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
End Sub

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)	
	
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData) 'ignore
	
End Sub


Public Sub StartScan
	If manager.State <> manager.STATE_POWERED_ON Then
		Log("Bluetooth OFF")
	Else If rp.Check(rp.PERMISSION_ACCESS_FINE_LOCATION) = False Then
		Log("No location permission.")
	Else
		Log("Start Scanning...")		
		manager.Scan2(Null, True)
	End If
End Sub


Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub
